#include <windows.h>
#include "SEH.h"

PDWORD AllocAndRandom()
{
       VirtualAlloc(&pMySEH, 0x1000, MEM_COMMIT, PAGE_READWRITE);
       
       return (PDWORD)((PUCHAR)&pMySEH+(GetTickCount() % 0x1000));
}
VOID SetSEHHandler()
{
     PEXCEPTION_REGISTRATION pCurrentHandler = NULL;
     PEXCEPTION_REGISTRATION pSavedHandler = NULL;
     
     
     /* Getting current handler 
        Normal syntax : 
               __asm{
                     MOV EAX, DWORD PTR FS:[0]
                     MOV pCurrentHandler, EAX
                     };
     */
     
     /* AT&T syntax */
     asm("mov %FS:(0), %eax");
     asm("mov %%eax, %%eax" : "=a"(pCurrentHandler));
     
     
     /* Getting last handler */
     while((DWORD)pCurrentHandler->prev != 0xFFFFFFFF)
     {
              pCurrentHandler = (PEXCEPTION_REGISTRATION)pCurrentHandler->prev;

     }
     
     pSavedHandler = pCurrentHandler;

     /* Building our SEH */
     if(pMySEH == NULL)
     {
         pMySEH = (PEXCEPTION_REGISTRATION)AllocAndRandom();
         pMySEH->prev = (PEXCEPTION_REGISTRATION)0xFFFFFFFF;
         pMySEH->handler = (PEXCEPTION_HANDLER)0x1337; // A bit useless
     }
     
     /* Installing the validation SEH */
     pCurrentHandler->prev = pMySEH;

     

     //ListHandlers();
     return;
}
/*
VOID ListHandlers()
{
     PEXCEPTION_REGISTRATION pCurrentHandler = NULL;
     
     asm("mov %FS:(0), %eax");
     asm("mov %%eax, %%eax" : "=a"(pCurrentHandler));
     
     /* Getting last handler *//*
     while((DWORD)pCurrentHandler->prev != 0xFFFFFFFF)
              pCurrentHandler = (PEXCEPTION_REGISTRATION)pCurrentHandler->prev;
     return;
     
}*/

VOID InStrSEHChain(PUCHAR pStr)
{
     PEXCEPTION_REGISTRATION pCurrentHandler = NULL;
     UCHAR tmp[512];

     asm("mov %FS:(0), %eax");
     asm("mov %%eax, %%eax" : "=a"(pCurrentHandler));
     
     do
     {
                                                                        
              sprintf(tmp, 
                      "+0x%x : Structured exception handler : \r\n   -> Handler : 0x%x\r\n   -> Previous SEH : 0x%x\r\n\r\n",
                      pCurrentHandler,
                      pCurrentHandler->handler,
                      pCurrentHandler->prev);

              strncat(pStr, tmp, strlen(tmp));
              memset(tmp, 0x0, sizeof(tmp));

              if((DWORD)pCurrentHandler->prev == 0xFFFFFFFF)
                                              break;
                    
              if(!IsValidSEHHandler(pCurrentHandler))
              {
                      strcat(pStr, "SEH chain corrupted !");
                      break;
              }
                                                                                             
              pCurrentHandler = (PEXCEPTION_REGISTRATION)pCurrentHandler->prev;
              
              
     }while(1);
     
     return;
}
BYTE IsSEHChainValid(PEXCEPTION_REGISTRATION pFirstHandler, PDWORD pdwNumberOfSEH)
{
     PEXCEPTION_REGISTRATION pCurrentHandler = pFirstHandler;
          
     while(pCurrentHandler->prev != pMySEH)
     {        
              
              /* If we get the end of the SEH chain without finding our SEH then return 0 */
              if((DWORD)pCurrentHandler->prev == 0xFFFFFFFF)
                                       return 0x00;
                                       
              *pdwNumberOfSEH++;
              
              if(!IsValidSEHHandler(pCurrentHandler))
                                                     return 0x00;
                                                                             
              pCurrentHandler = (PEXCEPTION_REGISTRATION)pCurrentHandler->prev;
     }    
  
     return 0x1;
}

BYTE IsValidSEHHandler(PEXCEPTION_REGISTRATION pCurrentHandler)
{
     //Check if the pointer to next SEH is valid
     if(!IsValidAddress(pCurrentHandler->prev))
                                             return 0x0;
                                                                                    
     //Check if previous SEH is in stack
     if(!IsInStack(pCurrentHandler->prev) && pCurrentHandler->prev != pMySEH)
                                          return 0x0;      
                                                                                                               
     //Check if the pointer to SEH handler is valid
     /* It is useless because of the previous verification */
     if(!IsValidAddress(pCurrentHandler->handler))
                                             return 0x0;
 
     return 0x1;
}     
