#include <windows.h>
#include "BeaEngine\BeaEngine.h"

BYTE IsValidAddress(DWORD dwAddress)
{
     MEMORY_BASIC_INFORMATION MemBasicInfo;
     BYTE ret = 0x0;
     
     ret = VirtualQuery((LPCVOID)dwAddress, &MemBasicInfo, 0x1C);
     
     /* If memory is not commited then return 0 */
     if(MemBasicInfo.State != MEM_COMMIT)
                          return 0;
                          
     return ret;
}
BYTE IsInStack(DWORD dwAddress)
{
     DWORD dwStackBase, dwStackTop; 
    
    //Getting stack limits
    
    /* AT&T syntax */
    asm("mov %FS:(8), %eax");
    asm("mov %%eax, %%eax" : "=a"(dwStackBase));
    
    asm("mov %FS:(4), %eax");
    asm("mov %%eax, %%eax" : "=a"(dwStackTop));
    
    /* Normal syntax (ex : Visual C++) :
              __asm{
                    MOV EAX, DWORD PTR FS:[8]
                    MOV dwStackBase, EAX
                    
                    MOV EAX, DWORD PTR FS:[4]
                    MOV dwStackTop, EAX
                    };
    */
    
    if(dwAddress < dwStackBase || dwAddress > dwStackTop)
                  return 0x0;
    
    return 0x1;
}
VOID DumpStackRegion(PUCHAR pDest, PUCHAR pSrc, DWORD dwSize)
{
     size_t i, j;
     UCHAR tmp[16] = {0x0};

     for(i = 0; i < dwSize; i+=4)
     {
           if( !IsInStack((DWORD)(pSrc+i+0x4)) )
               return;
           
           sprintf(tmp, "%x : ", (DWORD)(pSrc+i));
           strcat(pDest, tmp);
           for(j = 0; j < 4; j++)
           {
                 tmp[j] = pSrc[i+j];
                 sprintf(tmp, "%x ", tmp[j]);
                 strcat(pDest, tmp);
           }
           strcat(pDest, "\r\n");
           memset(tmp, 0x0, sizeof(tmp));
     }

     return;
}     

                       
PUCHAR InStrDisass(DWORD pAddr, DWORD dwDisassLen)
{
    PUCHAR pStr = (PUCHAR)calloc(dwDisassLen*128, sizeof(UCHAR));
    UCHAR tmp[128];// = {0x00};
    
       /* ============================= Init datas */
	DISASM MyDisasm;
	int false = 0, true = 1;
	int len, i = 0;
	int Error = 0;

	/* ============================= Init the Disasm structure (important !)*/
	(void) memset (&MyDisasm, 0, sizeof(DISASM));

	/* ============================= Init EIP */
	MyDisasm.EIP = pAddr;

	/* ============================= Loop for Disasm */
	while ((!Error) && (i<dwDisassLen)){
		len = Disasm(&MyDisasm);
		if (len != UNKNOWN_OPCODE) {

            sprintf(tmp, "%x : ", MyDisasm.EIP);
            strcat(tmp, MyDisasm.CompleteInstr);
            strcat(tmp, "\r\n");
			strcat(pStr, tmp);
			
			memset(tmp, 0, sizeof(tmp));
            
			MyDisasm.EIP = MyDisasm.EIP + len;
            i++;
		}
		else {
			Error = 1;
		}
	};
    return pStr;
}
